#define DEBUG_SERIAL 1
#define NUM_CONFIGURATIONS      1
#define NUM_INTERFACES          1
#define TRUE   1
#define FALSE  0
#define NULL   0
#define OLEN 128
#define ILEN 128
#define ConfiguredUSB() ((USWSTAT&0x3) == CONFIG_STATE)
#define STALL_EP0    	  if (debug_serial)  puts("stall 0"); set_bit(uep0,EPSTALL)
#define STALL_PID_EP0IN 	BDT[EP0IN].EPStat = 0xCC  /* REQUEST ERROR */
#define Send_0Len_pkt	BDT[EP0IN].Bytes = 0;	BDT[EP0IN].EPStat = 0xc8;	USB_dev_req = NULL;	
#define POWERED_STATE	        0x00
#define DEFAULT_STATE	        0x01
#define ADDRESS_STATE	        0x02
#define CONFIG_STATE	        0x03
#define ENDPT_DISABLED	        0x10  // For 18F2455 with handshaking
#define ENDPT_IN_ONLY	        0x12
#define ENDPT_OUT_ONLY	        0x14
#define ENDPT_CONTROL	        0x16	/* enable for in, out and setup */
#define ENDPT_NON_CONTROL		0x1E	/* enable for in, and out */
#define TOKEN_OUT	(0x01<<2)
#define TOKEN_ACK	(0x02<<2)
#define TOKEN_IN	(0x09<<2)
#define TOKEN_SETUP	(0x0D<<2)
#define CLEAR_FEATURE	        0x01
#define GET_CONFIGURATION	0x08
#define GET_DESCRIPTOR	        0x06
#define GET_INTERFACE	        0x0A
#define GET_STATUS	        0x00
#define SET_ADDRESS	        0x05
#define SET_CONFIGURATION	0x09
#define SET_FEATURE	        0x03
#define SET_INTERFACE	        0x0B
#define HOSTTODEVICE            0x00
#define HOSTTOINTERFACE         0x01
#define HOSTTOENDPOINT          0x02
#define DEVICETOHOST            0x80
#define INTERFACETOHOST         0x81
#define ENDPOINTTOHOST          0x82
#define DEVICE                  1  // Descriptor Types
#define CONFIGURATION           2
#define STRING                  3
#define INTERFACE               4
#define ENDPOINT                5
#define CS_INTERFACE            0x24
#define CS_ENDPOINT             0x25
volatile  bit  bDEV_ATT@UCON.USBEN;  //define some useful bit variables
volatile bit   bSUSPND@UCON.SUSPND;
volatile bit   bPKT_DIS@UCON.PKTDIS;
volatile  bit  bUIDLE@UIE.IDLEIE;
volatile  bit  bACTIVITY_E@UIE.ACTVIE;  //ENABLE BITS
volatile bit   bTOK_DONE_E@UIE.TRNIE; 
volatile bit  bPID_ERR_E@UEIE.PIDEE;
volatile bit  bCRC5_E@UEIE.CRC5EE;
volatile bit  bCRC16_E@UEIE.CRC16EE;
volatile bit  bDFN8_E@UEIE.DFN8EE;
volatile bit  bBTO_ERR_E@UEIE.BTOEE;
volatile bit  bBTS_ERR_E@UEIE.BTSEE;
volatile bit  bUSBRST_E@UIE.URSTIE;
volatile bit  bUSBIE@PIE2.USBIE;
volatile bit   bSTALL@UIR.STALLIF;  //FLAG BITS
volatile  bit  bUERR@UIR.UERRIF;
volatile bit  bPID_ERR@UEIR.PIDEF;
volatile bit  bCRC5@UEIR.CRC5EF; 
volatile  bit bCRC16@UEIR.CRC16EF;  
volatile bit  bDFN8@UEIR.DFN8EF;
volatile bit  bBTO_ERR@UEIR.BTOEF; 
volatile bit  bBTS_ERR@UEIR.BTSEF;
volatile bit bUSBIF@PIR2.USBIF;
volatile bit bUSBRST@UIR.URSTIF;
volatile bit bTMR0IF@INTCON.TMR0IF;
volatile bit   bACTIVITY@UIR.ACTVIF;
volatile bit   bTOK_DONE@UIR.TRNIF;
volatile bit bRCIE@PIE1.RCIE; //UART bits
volatile bit bRCIF@PIR1.RCIF;
volatile bit bTXIE@PIE1.TXIE;
volatile bit bTXIF@PIR1.TXIF;
volatile bit bGIE@INTCON.GIE;
volatile bit bFERR@RCSTA.FERR;
volatile bit bOERR@RCSTA.OERR;


// buffer register naming convention bdNXXXXDP  
// buffer naming convention bdNDP_buf, where  
//N is endpoint# = 0,1,2,3
//XXXX is the type: stat, cnt, adrl or adrh
//D is direction=i,o (in,out) 
//P is pingpong=e,o  (even,odd), pingpong buffering is not used in this application
// POINTERS IN THE BDT (buffer descriptor table) structure array
unsigned char EP0OUT=0;
unsigned char EP0IN=1;
unsigned char EP1OUT=2;
unsigned char EP1IN=3;
char bd0statoe@0x400; // ENDPOINT O OUT BDT[0]
char bd0cntoe@0x401=64; //Max # bytes that can be received or actual bytes received.
int  bd0adroe@0x402 =0x0500;
char bd0oe_buf[64] @0x500;  // define buffer for cpu
char bd0statie@0x404; // ENDPOINT O IN BDT[1]
char bd0cntie@0x405=0;  //# of bytes that will be transmitted to host or actual number transmitted.
int bd0adrie@0x406= 0x0540;
char bd0ie_buf[64] @0x540;  // define buffer for cpu
char bd1statoe@0x408;  // ENDPOINT 1 OUT BDT[2]
char bd1cntoe@0x409=64;
int bd1adroe@0x40a =0x0580;
char bd1oe_buf[64] @0x580;  // define buffer for cpu
char bd1statie@0x40c;  // ENDPOINT 1 IN BDT[3]
char bd1cntie@0x40d=0;
int bd1adrie@0x40e=0x05c0;
char bd1ie_buf[64] @0x5c0;  // define buffer for cpu

char outbuf[128] @0x600; // define serial buffers
char inbuf[128] @0x680;  // to 700
